#!/bin/bash
# Copyright (c) 2018 Cisco and/or its affiliates.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

function cmd {
    echo "[Command_start_exec] '$1'"
    echo -n "[Command_outputs] "
    eval ${@}
    echo "[Command_done_exec] '$1'"
    echo
}

echo
echo "[Command_desc] Starting ${0}"

if [ -f "/etc/redhat-release" ]; then
    cmd 'rpm -qai *vpp*'
else
    cmd 'dpkg -l | grep vpp'
fi

cmd 'ps aux | grep vpp'

cmd 'cat /etc/vpp/startup.conf'

cmd 'if fgrep docker /proc/1/cgroup; then supervisorctl restart vpp; else sudo -S service vpp restart; fi'

echo "[Command_desc] SLEEP for three seconds, so that VPP is up for sure"
cmd 'sleep 3'

cmd "sudo journalctl --no-pager --unit=vpp --since=\"$(echo `systemctl show -p ActiveEnterTimestamp vpp` | awk '{print $2 $3}')\""

cmd 'cat /proc/meminfo'

cmd 'free -m'

cmd 'ps aux | grep vpp'

cmd 'sudo dmidecode | grep UUID'

cmd 'lspci -Dnn'

echo "[Command_desc] Adding dpdk-input trace"
cmd 'sudo vpp_api_test <<< "exec trace add dpdk-input 50"'

echo "[Command_desc] Adding vhost-user-input trace"
cmd 'sudo vpp_api_test <<< "exec trace add vhost-user-input 50"'

echo "[Command_desc] Adding memif-input trace"
cmd 'sudo vpp_api_test <<< "exec trace add memif-input 50"'
